//================================================
/*

Ambient Aurea
Bring your image to an ambient lighting effect with just one click on the button.
Copyright (C) 2013 Stefan vd
www.stefanvd.net

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================

function $(id) { return document.getElementById(id); }
// settings
var default_opacity = null, interval = null, fadein = null, fadeout = null, lightcolor = null, ambilight = null, ambilightrangeblurradius = null, ambilightrangespreadradius = null, sharebar = null, count = null, slideshow = null, slideshowrefresh = null;

// firefox check that it not run in "chrome" page
// check if not on firefox "chrome" page
var lightschecktaburl = window.content.location.protocol;
if(lightschecktaburl != "chrome:"){

firefox.extension.sendRequest({name: "aarequest"}, function(response) {
// animation browser engine
window.requestAnimFrame = function(){
    return (
        window.requestAnimationFrame       || 
        window.webkitRequestAnimationFrame || 
        window.mozRequestAnimationFrame    || 
        window.oRequestAnimationFrame      || 
        window.msRequestAnimationFrame     || 
        function(/* function */ callback){
            window.setTimeout(callback, 1000 / 60);
        }
    );
}();

// Fade engine
//  Variable for the fade in and out effect
var opacity = 0;

var ReducingFinished = true;
var OpacityLevelIncrement = 10;   //  Percentage value: 1-100

//  Function determines whether we show or hide the item referenced by ElementID
function fader(ActionToTake)
{
  DIVElementById = $('stefanvdaalightareoff1');
  if (ActionToTake == 'hide')
  { opacity = default_opacity; reduceOpacity(); }
  else if (ActionToTake == 'show')
  { increaseOpacity(); }
}

//  Makes div increase
function increaseOpacity()
{
try {
  //  If opacity level is less than default_opacity, we can still increase the opacity
  if ((opacity < default_opacity) && (ReducingFinished == true))
  {
	if ((opacity > (default_opacity-10)) && (ReducingFinished == true)){
    ReducingFinished = true;
    opacity  += (default_opacity - opacity);
	DIVElementById.style.opacity = opacity/100;
	window.requestAnimFrame(increaseOpacity);
	}
	else {
    ReducingFinished = true;
    opacity  += OpacityLevelIncrement;
	DIVElementById.style.opacity = opacity/100;
	window.requestAnimFrame(increaseOpacity);
	}
  }
  else
  {
    ReducingFinished = false;
  }
//control opacity for all <div>
var div = document.querySelectorAll('div.stefanvdaalightareoff');
for(var i = 0; i < div.length; i++ ){div[i].style.opacity = opacity/100;}
} catch(e){}
}

//  Makes div reduce
function reduceOpacity() 
{
try {
  //  If opacity level is greater than 0, we can still reduce the opacity
  if ((opacity > 0) && (ReducingFinished == false))
  {
    ReducingFinished = false;
    opacity  -= OpacityLevelIncrement;
    DIVElementById.style.opacity = opacity/100;
	window.requestAnimFrame(reduceOpacity);
  }
  else
  {
    ReducingFinished = true;

    //  When finished, make sure the DIVElementById is set to remove element
    if (DIVElementById.style.opacity = '0')
    {document.body.removeChild(DIVElementById);}
  }
//control opacity for all <div>
var div = document.querySelectorAll('div.stefanvdaalightareoff');
for(var i = 0; i < div.length; i++ ){div[i].style.opacity = opacity/100;}
} catch(e){}
}

contextmenus = response.contextmenus;
interval = response.interval;default_opacity = interval; // default interval 80%
fadein = response.fadein;
fadeout = response.fadeout;
lightcolor = response.lightcolor;
ambilight = response.ambilight;
ambilightrangeblurradius = response.ambilightrangeblurradius;
ambilightrangespreadradius = response.ambilightrangespreadradius;
ambilightfixcolor = response.ambilightfixcolor;
ambilight4color = response.ambilight4color;
ambilightvarcolor = response.ambilightvarcolor;
ambilightcolorhex = response.ambilightcolorhex;
ambilight1colorhex = response.ambilight1colorhex;
ambilight2colorhex = response.ambilight2colorhex;
ambilight3colorhex = response.ambilight3colorhex;
ambilight4colorhex = response.ambilight4colorhex;
sharebar = response.sharebar;
count = response.count;
slideshow = response.slideshow;
slideshowrefresh = response.slideshowrefresh;

//---- cleanup service
function cleanup() {
var stefanvdaapaneltopl = $('stefanvdaapaneltopl');
if(stefanvdaapaneltopl) {document.body.removeChild(stefanvdaapaneltopl);}
var stefanvdaapaneltopr = $('stefanvdaapaneltopr');
if(stefanvdaapaneltopr) {document.body.removeChild(stefanvdaapaneltopr);}
var stefanvdaapaneltop = $('stefanvdaapaneltop');
if(stefanvdaapaneltop) {document.body.removeChild(stefanvdaapaneltop);}
var stefanvdaashare = $('stefanvdaashare');
if(stefanvdaashare) {document.body.removeChild(stefanvdaashare);}
var stefanvdaasharepanel = $('stefanvdaasharepanel');
if(stefanvdaasharepanel) {document.body.removeChild(stefanvdaasharepanel);}
var stefanvdaagallery = $('stefanvdaagallery');
if(stefanvdaagallery) {document.body.removeChild(stefanvdaagallery);}
var stefanvdaagallerybuttonleft = $('stefanvdaagallerybuttonleft');
if(stefanvdaagallerybuttonleft) {document.body.removeChild(stefanvdaagallerybuttonleft);}
var stefanvdaagallerybuttonright = $('stefanvdaagallerybuttonright');
if(stefanvdaagallerybuttonright) {document.body.removeChild(stefanvdaagallerybuttonright);}
var stefanvdaagallerycounter = $('stefanvdaagallerycounter');
if(stefanvdaagallerycounter) {document.body.removeChild(stefanvdaagallerycounter);}
var stefanvdaaslideshow = $('stefanvdaaslideshow');
if(stefanvdaaslideshow) {document.body.removeChild(stefanvdaaslideshow);window.clearTimeout(countss);}

j = 0;
}

function refreshambilight(){
	var totlshowtime = document.querySelectorAll('img.stefanvdaagalleryimageshow');
	for(var i = 0; i < totlshowtime.length; i++ ){totlshowtime = totlshowtime[i];}
	var getblur = ambilightrangeblurradius + "px";
	var getspread = ambilightrangespreadradius + "px";

if(ambilightvarcolor == true){
    var sourceWidth = totlshowtime.width;
    var sourceHeight = totlshowtime.height;

	var totlcheckcanvas = $("aaCanvas1");
	if(totlcheckcanvas){} else{
 	var totlnewcanvas = document.createElement("canvas");
	totlnewcanvas.setAttribute('id','aaCanvas1');
	totlnewcanvas.width = "4";
	totlnewcanvas.height = "1";
	totlnewcanvas.style.display = "none";
	document.body.appendChild(totlnewcanvas);
	}
	
var canvas = $("aaCanvas1");
var context = canvas.getContext('2d');

var colorlamp1X = (sourceWidth * 50) /100; // up midden
var colorlamp1Y = (sourceHeight * 95) /100;
var colorlamp2X = (sourceWidth * 95) /100; // right midden
var colorlamp2Y = (sourceHeight * 50) /100;
var colorlamp3X = (sourceWidth * 50) /100; // down midden
var colorlamp3Y = (sourceHeight * 5) /100;
var colorlamp4X = (sourceWidth * 5) /100; // left midden
var colorlamp4Y = (sourceHeight * 50) /100;

	context.drawImage(totlshowtime, colorlamp1X, colorlamp1Y, 1, 1, 0, 0, 1, 1);
	context.drawImage(totlshowtime, colorlamp2X, colorlamp2Y, 1, 1, 1, 0, 1, 1);
	context.drawImage(totlshowtime, colorlamp3X, colorlamp3Y, 1, 1, 2, 0, 1, 1);
	context.drawImage(totlshowtime, colorlamp4X, colorlamp4Y, 1, 1, 3, 0, 1, 1);

try{
	var imageData = context.getImageData(0, 0, 1, 1);
	var data = imageData.data;

	function rgbToHex(r, g, b) {
    if (r > 255 || g > 255 || b > 255)
        throw "Invalid color component";
    return ((r << 16) | (g << 8) | b).toString(16);
	}

	var p1 = context.getImageData(0 , 0, 1, 1).data;
	var p2 = context.getImageData(1 , 0, 1, 1).data;
	var p3 = context.getImageData(2 , 0, 1, 1).data;
	var p4 = context.getImageData(3 , 0, 1, 1).data;
	var hex1 = "#" + ("000000" + rgbToHex(p1[0], p1[1], p1[2])).slice(-6);
	var hex2 = "#" + ("000000" + rgbToHex(p2[0], p2[1], p2[2])).slice(-6);
	var hex3 = "#" + ("000000" + rgbToHex(p3[0], p3[1], p3[2])).slice(-6);
	var hex4 = "#" + ("000000" + rgbToHex(p4[0], p4[1], p4[2])).slice(-6);

	totlshowtime.style.setProperty("box-shadow", "0px 0px 5px black , 0px -20px " + getblur + " " + getspread + " " + hex3 + ", 0px 20px " + getblur + " " + getspread + " " + hex1 + ", 20px 0px " + getblur + " " + getspread + " " + hex2 + ", -20px 0px " + getblur + " " + getspread + " " + hex4 + "", "");
}catch(e) {
	totlshowtime.style.setProperty("box-shadow", "0px 0px 5px black , 0px -20px " + getblur + " " + getspread + " " + ambilightcolorhex + ", 0px 20px " + getblur + " " + getspread + " " + ambilightcolorhex + ", 20px 0px " + getblur + " " + getspread + " " + ambilightcolorhex + ", -20px 0px " + getblur + " " + getspread + " " + ambilightcolorhex + "", "");
}
}
else if (ambilightfixcolor == true){
	totlshowtime.style.webkitBoxShadow = "0px 0px 5px black , 0px -20px " + getblur + " " + getspread + " " + ambilightcolorhex + ", 0px 20px " + getblur + " " + getspread + " " + ambilightcolorhex + ", 20px 0px " + getblur + " " + getspread + " " + ambilightcolorhex + ", -20px 0px " + getblur + " " + getspread + " " + ambilightcolorhex + "";
} else if(ambilight4color == true){
	var hex1 = ambilight1colorhex;
	var hex2 = ambilight2colorhex;
	var hex3 = ambilight3colorhex;
	var hex4 = ambilight4colorhex;
	totlshowtime.style.setProperty("box-shadow", "0px 0px 5px black , 0px -20px " + getblur + " " + getspread + " " + hex3 + ", 0px 20px " + getblur + " " + getspread + " " + hex1 + ", 20px 0px " + getblur + " " + getspread + " " + hex2 + ", -20px 0px " + getblur + " " + getspread + " " + hex4 + "", "");
}
}

// calc screen size
var screenwidth = document.documentElement.clientWidth;var screenheight = document.documentElement.clientHeight;
var j = 0;

// build gallery frame
var newaagallery = document.createElement('div');
newaagallery.setAttribute('id','stefanvdaagallery');
document.body.appendChild(newaagallery);

var img = document.querySelectorAll('img');
for(var i = 0; i < img.length; i++ ){
// calc if size is not zero
var height = img[i].naturalHeight;
var width = img[i].naturalWidth;
if((width > 1 || height > 1) && (img[i].src != "")){
var newaaimage = document.createElement('img');
j += 1;
if(width > screenwidth){ // autozoom
var c1 = width - screenwidth;
var c3 = screenwidth - c1;
newaaimage.width = c3-50;
}
else if(height > screenheight){
var c2 = height - screenheight;
var c4 = screenheight - c2;
newaaimage.height = c4-50;
}
else if((height >= screenheight) && (width >= screenwidth)){newaaimage.height = screenheight/1.5;}
else if((height == screenheight-1)){newaaimage.height = screenheight/1.5;}
else{}
newaaimage.onload = function(e) {resizeframe();refreshambilight();refreshcounter();};
newaaimage.setAttribute('id','stefanvdaagalleryimage' + j + '');
newaaimage.setAttribute('class','stefanvdaagalleryimagehide');
newaaimage.src = img[i].src;
newaagallery.appendChild(newaaimage);
}
}
// first receive the show
$('stefanvdaagalleryimage' + '1' + '').setAttribute('class','stefanvdaagalleryimageshow');
sourceImageWidth = $('stefanvdaagalleryimage' + '1' + '').clientWidth;
sourceImageHeight = $('stefanvdaagalleryimage' + '1' + '').clientHeight;
newaagallery.style.left = (screenwidth/2) - (sourceImageWidth/2) + "px";
newaagallery.style.top = (screenheight/2) - (sourceImageHeight/2) + "px";
refreshambilight();

// button next and previous image
var kmax = j;
// button left
var newaagalleryleft = document.createElement('div');
newaagalleryleft.setAttribute('id','stefanvdaagallerybuttonleft');
newaagalleryleft.style.left = "20px";
newaagalleryleft.style.top = (screenheight/2) - 42 + "px";
newaagalleryleft.addEventListener("click", function() {
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimagehide');
if(j == 1){j = kmax;}
else {j-=1;}
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimageshow');
resizeframe();refreshambilight();refreshcounter();
});
document.body.appendChild(newaagalleryleft);
// button right
var newaagalleryright = document.createElement('div');
newaagalleryright.setAttribute('id','stefanvdaagallerybuttonright');
newaagalleryright.style.right = "20px";
newaagalleryright.style.top = (screenheight/2) - 42 + "px";
newaagalleryright.addEventListener("click", function() {
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimagehide');
if(j == kmax){j = 1;}
else {j+=1;}
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimageshow');
resizeframe();refreshambilight();refreshcounter();
});
document.body.appendChild(newaagalleryright);

window.addEventListener('keydown', function(e) {
	var lightareoff = $('stefanvdaalightareoff1');
	if (lightareoff != null) {
		if (e.which == 37) {
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimagehide');
if(j == 1){j = kmax;}
else {j-=1;}
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimageshow');
resizeframe();refreshambilight();refreshcounter();
		} else if (e.which == 39) {
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimagehide');
if(j == kmax){j = 1;}
else {j+=1;}
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimageshow');
resizeframe();refreshambilight();refreshcounter();		
		}
	}
}, false);

// reset j to 1 first slide in the counter text
j = 1;

if(count == true){
var newcounter = document.createElement('div');
newcounter.setAttribute('id','stefanvdaagallerycounter');
newcounter.textContent = "" + j + "/" + kmax + ""
document.body.appendChild(newcounter);
}

function refreshcounter(){
if(count == true){
$('stefanvdaagallerycounter').textContent = "" + j + "/" + kmax + "";
}
}

function resizeframe(){
var newscreenheight = document.documentElement.clientHeight;
var newscreenwidth = document.documentElement.clientWidth;
sourceImageWidth = $('stefanvdaagalleryimage' + j + '').width;
sourceImageHeight = $('stefanvdaagalleryimage' + j + '').height;
newaagallery.style.left = (newscreenwidth/2) - (sourceImageWidth/2) + "px";
newaagallery.style.top = (newscreenheight/2) - (sourceImageHeight/2) + "px";
}

window.addEventListener('resize', function(){resizeframe();}, false);

var blackon = $('stefanvdaalightareoff1');
if(blackon) {
// fade out effect
if(fadeout == true){fader('hide');cleanup();}
else{document.body.removeChild(blackon);cleanup();}
} else{

var getdomimage = "";

var newdiv = document.createElement('div'); 
newdiv.setAttribute('id','stefanvdaalightareoff1');
newdiv.setAttribute('class','stefanvdaalightareoff');
newdiv.style.width = '100%'; 
newdiv.style.height = '100%'; 
newdiv.style.left = 0; 
newdiv.style.top = 0; 
newdiv.style.position = 'fixed';
newdiv.style.background = lightcolor;
newdiv.style.opacity = 1;
newdiv.style.zIndex = 999;
document.body.appendChild(newdiv);

// fade out effect
if(fadeout == true){newdiv.addEventListener("click", function() {fader('hide');cleanup();})}
else{newdiv.addEventListener("click", function() {document.body.removeChild(newdiv);cleanup();})}

// fade in effect
if(fadein == true){fader('show');}
else{newdiv.style.opacity = default_opacity/100} // no fade effect	
	
// ambilight time
if(ambilight == true){ // yes show time
refreshambilight();
}

// sharebar
if(sharebar == true){
var currenturl = window.location.href;var currentencodeurl = encodeURIComponent(currenturl);
var stefanvdurl = "https://addons.mozilla.org/en-US/firefox/addon/ambient-aurea/";var stefanvdaacodeurl = encodeURIComponent(stefanvdurl);

var newdivshare = document.createElement('div');
newdivshare.setAttribute('id','stefanvdaasharepanel');
document.body.appendChild(newdivshare);

var sharegp = document.createElement('img');
sharegp.setAttribute('id','stefanvdgoogleplusshare');
sharegp.src = 'chrome://AmbientAurea/content/images/googleplus.png';
sharegp.addEventListener("click", function() {window.open('https://plus.google.com/share?ur\l=' + currentencodeurl + '', 'Share to Google+','width=600,height=460,menubar=no,location=no,status=no');});
newdivshare.appendChild(sharegp);

var sharefb = document.createElement('img');
sharefb.setAttribute('id','stefanvdfacebookshare');
sharefb.src = 'chrome://AmbientAurea/content/images/facebook.png';
sharefb.addEventListener("click", function() {window.open("https://www.facebook.com/sharer.php?u="+ currenturl + "[URL]&t=Try this out, i am focus the image with Ambient Aurea browser extension! http://www.stefanvd.net/project/ambientaurea.htm", "_blank");});
newdivshare.appendChild(sharefb);

var sharetw = document.createElement('img');
sharetw.setAttribute('id','stefanvdtwittershare');
sharetw.src = 'chrome://AmbientAurea/content/images/twitter.png';
sharetw.addEventListener("click", function() {window.open("https://twitter.com/share?url=" + currentencodeurl + "&text=Try this out, i am focus the image with Ambient Aurea browser extension! http://www.stefanvd.net/project/ambientaurea.htm", 'Share to Twitter','width=600,height=460,menubar=no,location=no,status=no');});
newdivshare.appendChild(sharetw);
}

if(slideshow == true){
var countss; // slideshow counter

var newdivslideshow = document.createElement('div');
newdivslideshow.setAttribute('id','stefanvdaaslideshow');
document.body.appendChild(newdivslideshow);

var newdivslideshowplay = document.createElement('a');
newdivslideshowplay.setAttribute('id','stefanvdaaplaybutton');
newdivslideshowplay.setAttribute('class','play stefanvdaaicon');
newdivslideshowplay.style.display = "";
newdivslideshowplay.addEventListener("click", function() {
$('stefanvdaaplaybutton').style.display = "none";$('stefanvdaapreviousbutton').style.display = "";slideshowtimernext();
});
newdivslideshow.appendChild(newdivslideshowplay);
var newdivslideshowpause = document.createElement('a');
newdivslideshowpause.setAttribute('id','stefanvdaapreviousbutton');
newdivslideshowpause.setAttribute('class','pause stefanvdaaicon');
newdivslideshowpause.style.display = "none";
newdivslideshowpause.addEventListener("click", function() {
$('stefanvdaaplaybutton').style.display = "";$('stefanvdaapreviousbutton').style.display = "none";window.clearTimeout(countss);
});
newdivslideshow.appendChild(newdivslideshowpause);

function slideshownext(){
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimagehide');
if(j == kmax){j = 1;}
else {j+=1;}
$('stefanvdaagalleryimage' + j + '').setAttribute('class','stefanvdaagalleryimageshow');
slideshowtimernext();
resizeframe();refreshambilight();refreshcounter();
}
function slideshowtimernext(){countss = setTimeout(slideshownext, slideshowrefresh * 1000);}

}

}

});

}