//================================================
/*

Ambient Aurea
Bring your image to an ambient lighting effect with just one click on the button.
Copyright (C) 2013 Stefan vd
www.stefanvd.net

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================

addNewStyleSheetByFullCSS();
function addNewStyleSheetByFullCSS() {
var fileref = document.createElement("link");
fileref.setAttribute("rel", "stylesheet");
fileref.setAttribute("type", "text/css");
fileref.setAttribute("href", "chrome://AmbientAurea/content/css/aa.css");
var h=document.getElementsByTagName("head");if(!h.length)return;
h[0].appendChild(fileref);
}

function $(id) { return document.getElementById(id); }

// Install on www.stefanvd.net
if (window.location.href.match(/http:\/\/(.*stefanvd\.net\/.*|www\.stefanvd\.net\/.*\/.*)/i)){
	if ($('ambientaurea-firefox-install-button')) {
		$('ambientaurea-firefox-install-button').style.display = 'none';
		$('ambientaurea-firefox-thanks-button').style.display = '';
	}
}

firefox.extension.sendRequest({name: "aarequest"}, function(response) {

var last_target = null;
document.addEventListener('mousedown', function(event){
var goimage = event.target.src;
if (typeof goimage === "undefined"){}else{
firefox.extension.sendRequest({name: 'imgurl', value : goimage});
}

}, true);

});